#include <map>

#include "text_t.h"

class oaiargs
{
 private:
  text_tmap arguments;
  text_t    dummy;
  bool      duplicateArg;
  // fill the input buffer to parse the arguments
  void fillBuffer(istream &stream, unsigned char *buffer, unsigned char **currentPtr, unsigned char *end);
 public:
  oaiargs() { this->duplicateArg = false; }

  const text_t &operator [](const text_t &label) { 
    if (this->arguments.count(label) > 0) {
      return this->arguments[label]; 
    }
    return dummy; // Dodgy, but text_t's are initialised to "", so should be fine
  };
  void readArgs(istream &stream);
  bool hasDuplicateArg() { return this->duplicateArg; }
  int getSize(){return arguments.size();}
  text_tmap::const_iterator begin(){return arguments.begin();};
  text_tmap::const_iterator end(){return arguments.end();};
};
